diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-content/plugins/wp-super-cache/wp-cache.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-content/plugins/wp-super-cache/wp-cache.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-content/plugins/wp-super-cache/wp-cache.php	2013-10-30 20:29:20.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-content/plugins/wp-super-cache/wp-cache.php	2014-08-08 20:30:29.000000000 +0400
***************
*** 2679,2685 ****
  			if ( !isset( $wp_super_cache_front_page_clear ) || ( isset( $wp_super_cache_front_page_clear ) && $wp_super_cache_front_page_clear == 0 ) ) {
                                  wp_mail( get_option( 'admin_email' ), sprintf( __( '[%s] Front page is not correct! Please clear cache!', 'wp-super-cache' ), site_url() ), sprintf( __( 'Please visit %1$s to clear the cache as the front page of your site is not correct and missing the text, "%2$s"!', 'wp-super-cache' ), trailingslashit( site_url() ) . "wp-admin/options-general.php?page=wpsupercache", $wp_super_cache_front_page_text ) );
                          } else {
!                                 wp_cache_clear_cache();
                                  wp_mail( get_option( 'admin_email' ), sprintf( __( '[%s] Front page is not correct! Cache Cleared!', 'wp-super-cache' ), site_url() ), sprintf( __( 'The cache on your blog has been cleared because the front page of your site is missing the text "%2$s". Please visit %1$s to verify the cache has been cleared.', 'wp-super-cache' ), trailingslashit( site_url() ) . "wp-admin/options-general.php?page=wpsupercache", $wp_super_cache_front_page_text ) );
  			}
  		}
--- 2679,2685 ----
  			if ( !isset( $wp_super_cache_front_page_clear ) || ( isset( $wp_super_cache_front_page_clear ) && $wp_super_cache_front_page_clear == 0 ) ) {
                                  wp_mail( get_option( 'admin_email' ), sprintf( __( '[%s] Front page is not correct! Please clear cache!', 'wp-super-cache' ), site_url() ), sprintf( __( 'Please visit %1$s to clear the cache as the front page of your site is not correct and missing the text, "%2$s"!', 'wp-super-cache' ), trailingslashit( site_url() ) . "wp-admin/options-general.php?page=wpsupercache", $wp_super_cache_front_page_text ) );
                          } else {
!                                 wp_cache_clear_cache( get_current_blog_id() );
                                  wp_mail( get_option( 'admin_email' ), sprintf( __( '[%s] Front page is not correct! Cache Cleared!', 'wp-super-cache' ), site_url() ), sprintf( __( 'The cache on your blog has been cleared because the front page of your site is missing the text "%2$s". Please visit %1$s to verify the cache has been cleared.', 'wp-super-cache' ), trailingslashit( site_url() ) . "wp-admin/options-general.php?page=wpsupercache", $wp_super_cache_front_page_text ) );
  			}
  		}
***************
*** 2709,2715 ****
  		$wp_cache_mobile_groups = $mobile_groups;
  		wp_cache_replace_line('^ *\$wp_cache_mobile_groups', "\$wp_cache_mobile_groups = '" . implode( ', ', $mobile_groups ) . "';", $wp_cache_config_file);
  	}
! 	
  	return true;
  }
  
--- 2709,2715 ----
  		$wp_cache_mobile_groups = $mobile_groups;
  		wp_cache_replace_line('^ *\$wp_cache_mobile_groups', "\$wp_cache_mobile_groups = '" . implode( ', ', $mobile_groups ) . "';", $wp_cache_config_file);
  	}
! 
  	return true;
  }
  
***************
*** 2742,2761 ****
  		if ( !isset( $wpmu_version ) || $wpmu_version == '' ) {
  			echo '<form name="updatehtaccess" action="#modrewrite" method="post">';
  			echo '<input type="hidden" name="updatehtaccess" value="1" />';
! 			echo '<div class="submit"><input type="submit" ' . SUBMITDISABLED . 'id="updatehtaccess" value="' . __( 'Update Mod_Rewrite Rules', 'wp-super-cache' ) . ' &raquo;" /></div>';
  			wp_nonce_field('wp-cache');
  			echo "</form></div>\n";
  		}
  	}
  }
  
! /* 
   * Return LOGGED_IN_COOKIE if it doesn't begin with wordpress_logged_in
   * to avoid having people update their .htaccess file
   */
  function wpsc_get_logged_in_cookie() {
  	$logged_in_cookie = 'wordpress_logged_in';
! 	if ( defined( 'LOGGED_IN_COOKIE' ) && substr( constant( 'LOGGED_IN_COOKIE' ), 0, 19 ) != 'wordpress_logged_in' ) 
  		$logged_in_cookie = constant( 'LOGGED_IN_COOKIE' );
  	return $logged_in_cookie;
  }
--- 2742,2761 ----
  		if ( !isset( $wpmu_version ) || $wpmu_version == '' ) {
  			echo '<form name="updatehtaccess" action="#modrewrite" method="post">';
  			echo '<input type="hidden" name="updatehtaccess" value="1" />';
! 			echo '<div class="submit"><input class="button-primary" type="submit" ' . SUBMITDISABLED . 'id="updatehtaccess" value="' . __( 'Update Mod_Rewrite Rules', 'wp-super-cache' ) . '" /></div>';
  			wp_nonce_field('wp-cache');
  			echo "</form></div>\n";
  		}
  	}
  }
  
! /*
   * Return LOGGED_IN_COOKIE if it doesn't begin with wordpress_logged_in
   * to avoid having people update their .htaccess file
   */
  function wpsc_get_logged_in_cookie() {
  	$logged_in_cookie = 'wordpress_logged_in';
! 	if ( defined( 'LOGGED_IN_COOKIE' ) && substr( constant( 'LOGGED_IN_COOKIE' ), 0, 19 ) != 'wordpress_logged_in' )
  		$logged_in_cookie = constant( 'LOGGED_IN_COOKIE' );
  	return $logged_in_cookie;
  }
***************
*** 2807,2815 ****
  	$condition_rules[] = "RewriteCond %{HTTP:X-Wap-Profile} !^[a-z0-9\\\"]+ [NC]";
  	$condition_rules[] = "RewriteCond %{HTTP:Profile} !^[a-z0-9\\\"]+ [NC]";
  	if ( $wp_cache_mobile_enabled ) {
! 		if ( false == empty( $wp_cache_mobile_browsers ) ) 
  			$condition_rules[] = "RewriteCond %{HTTP_USER_AGENT} !^.*(" . addcslashes( implode( '|', $wp_cache_mobile_browsers ), ' ' ) . ").* [NC]";
! 		if ( false == empty( $wp_cache_mobile_prefixes ) ) 
  			$condition_rules[] = "RewriteCond %{HTTP_user_agent} !^(" . addcslashes( implode( '|', $wp_cache_mobile_prefixes ), ' ' ) . ").* [NC]";
  	}
  	$condition_rules = apply_filters( 'supercacherewriteconditions', $condition_rules );
--- 2807,2815 ----
  	$condition_rules[] = "RewriteCond %{HTTP:X-Wap-Profile} !^[a-z0-9\\\"]+ [NC]";
  	$condition_rules[] = "RewriteCond %{HTTP:Profile} !^[a-z0-9\\\"]+ [NC]";
  	if ( $wp_cache_mobile_enabled ) {
! 		if ( false == empty( $wp_cache_mobile_browsers ) )
  			$condition_rules[] = "RewriteCond %{HTTP_USER_AGENT} !^.*(" . addcslashes( implode( '|', $wp_cache_mobile_browsers ), ' ' ) . ").* [NC]";
! 		if ( false == empty( $wp_cache_mobile_prefixes ) )
  			$condition_rules[] = "RewriteCond %{HTTP_user_agent} !^(" . addcslashes( implode( '|', $wp_cache_mobile_prefixes ), ' ' ) . ").* [NC]";
  	}
  	$condition_rules = apply_filters( 'supercacherewriteconditions', $condition_rules );
***************
*** 2867,2873 ****
  	if ( isset( $GLOBALS[ 'wp_super_cache_debug' ] ) && $GLOBALS[ 'wp_super_cache_debug' ] ) wp_cache_debug( "clear_post_supercache: deleting $dir/index*.html files", 2 );
  	$files_to_check = get_all_supercache_filenames( $dir );
  	foreach( $files_to_check as $cache_file ) {
! 		prune_super_cache( $dir . $cache_file, true ); 
  	}
  }
  
--- 2867,2873 ----
  	if ( isset( $GLOBALS[ 'wp_super_cache_debug' ] ) && $GLOBALS[ 'wp_super_cache_debug' ] ) wp_cache_debug( "clear_post_supercache: deleting $dir/index*.html files", 2 );
  	$files_to_check = get_all_supercache_filenames( $dir );
  	foreach( $files_to_check as $cache_file ) {
! 		prune_super_cache( $dir . $cache_file, true );
  	}
  }
  
***************
*** 3111,3117 ****
  			$code .= "<li><code>chmod 666 " . WP_CONTENT_DIR . "/{$filename}</code></li>\n";
  		}
  		$code .= "</ul>\n";
! 		
  		$msg .= "</ol>\n<p>First try fixing the directory permissions with this command and refresh this page:<br /><br /><code>chmod 777 " . WP_CONTENT_DIR . "</code><br /><br />If you still see this error, you have to fix the permissions on the files themselves and refresh this page again:</p> {$code}\n<p>Don't forgot to fix things later:<br /><code>chmod 755 " . WP_CONTENT_DIR . "</code></p><p>If you don't know what <strong>chmod</strong> is use <a href='http://www.google.ie/search?hl=en&q=ftp+chmod+777'>this Google search</a> to find out all about it.</p><p>Please refresh this page when the permissions have been modified.</p>";
  		wp_die( $msg );
  	}
--- 3111,3117 ----
  			$code .= "<li><code>chmod 666 " . WP_CONTENT_DIR . "/{$filename}</code></li>\n";
  		}
  		$code .= "</ul>\n";
! 
  		$msg .= "</ol>\n<p>First try fixing the directory permissions with this command and refresh this page:<br /><br /><code>chmod 777 " . WP_CONTENT_DIR . "</code><br /><br />If you still see this error, you have to fix the permissions on the files themselves and refresh this page again:</p> {$code}\n<p>Don't forgot to fix things later:<br /><code>chmod 755 " . WP_CONTENT_DIR . "</code></p><p>If you don't know what <strong>chmod</strong> is use <a href='http://www.google.ie/search?hl=en&q=ftp+chmod+777'>this Google search</a> to find out all about it.</p><p>Please refresh this page when the permissions have been modified.</p>";
  		wp_die( $msg );
  	}
***************
*** 3119,3125 ****
  	if ( $scrules != '' && insert_with_markers( $home_path.'.htaccess', 'WPSuperCache', array() ) ) {
  		$wp_rewrite->flush_rules();
  	} elseif( $scrules != '' ) {
! 		wp_mail( get_option( 'admin_email' ), __( 'Supercache Uninstall Problems', 'wp-super-cache' ), sprintf( __( "Dear User,\n\nWP Super Cache was removed from your blog but the mod_rewrite rules\nin your .htaccess were not.\n\nPlease edit the following file and remove the code\nbetween 'BEGIN WPSuperCache' and 'END WPSuperCache'. Please backup the file first!\n\n%s\n\nRegards,\nWP Super Cache Plugin\nhttp://wordpress.org/extend/plugins/wp-super-cache/", 'wp-super-cache' ), ABSPATH . '/.htaccess' ) );
  	}
  }
  
--- 3119,3125 ----
  	if ( $scrules != '' && insert_with_markers( $home_path.'.htaccess', 'WPSuperCache', array() ) ) {
  		$wp_rewrite->flush_rules();
  	} elseif( $scrules != '' ) {
! 		wp_mail( get_option( 'admin_email' ), __( 'Supercache Uninstall Problems', 'wp-super-cache' ), sprintf( __( "Dear User,\n\nWP Super Cache was removed from your blog but the mod_rewrite rules\nin your .htaccess were not.\n\nPlease edit the following file and remove the code\nbetween 'BEGIN WPSuperCache' and 'END WPSuperCache'. Please backup the file first!\n\n%s\n\nRegards,\nWP Super Cache Plugin\nhttp://wordpress.org/plugins/wp-super-cache/", 'wp-super-cache' ), ABSPATH . '/.htaccess' ) );
  	}
  }
  
***************
*** 3130,3136 ****
  		$dh  = @opendir($folderPath);
  		while( false !== ( $value = @readdir( $dh ) ) ) {
  			if ( $value != "." && $value != ".." ) {
! 				$value = $folderPath . "/" . $value; 
  				if ( @is_dir ( $value ) ) {
  					uninstall_supercache( $value );
  				} else {
--- 3130,3136 ----
  		$dh  = @opendir($folderPath);
  		while( false !== ( $value = @readdir( $dh ) ) ) {
  			if ( $value != "." && $value != ".." ) {
! 				$value = $folderPath . "/" . $value;
  				if ( @is_dir ( $value ) ) {
  					uninstall_supercache( $value );
  				} else {
***************
*** 3146,3152 ****
  
  function supercache_admin_bar_render() {
  	global $wp_admin_bar, $wp_cache_not_logged_in;
! 	if ( !is_user_logged_in() || !$wp_cache_not_logged_in ) 
  		return false;
  
  	if ( function_exists('current_user_can') && false == current_user_can('delete_others_posts') )
--- 3146,3152 ----
  
  function supercache_admin_bar_render() {
  	global $wp_admin_bar, $wp_cache_not_logged_in;
! 	if ( !is_user_logged_in() || !$wp_cache_not_logged_in )
  		return false;
  
  	if ( function_exists('current_user_can') && false == current_user_can('delete_others_posts') )
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/bookmark.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/bookmark.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/bookmark.php	2013-10-30 20:29:22.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/bookmark.php	2014-04-03 07:23:10.000000000 +0400
***************
*** 208,215 ****
  		$join = " INNER JOIN $wpdb->term_relationships AS tr ON ($wpdb->links.link_id = tr.object_id) INNER JOIN $wpdb->term_taxonomy as tt ON tt.term_taxonomy_id = tr.term_taxonomy_id";
  	}
  
! 	if ( $show_updated && get_option('links_recently_updated_time') ) {
! 		$recently_updated_test = ", IF (DATE_ADD(link_updated, INTERVAL " . get_option('links_recently_updated_time') . " MINUTE) >= NOW(), 1,0) as recently_updated ";
  	} else {
  		$recently_updated_test = '';
  	}
--- 208,215 ----
  		$join = " INNER JOIN $wpdb->term_relationships AS tr ON ($wpdb->links.link_id = tr.object_id) INNER JOIN $wpdb->term_taxonomy as tt ON tt.term_taxonomy_id = tr.term_taxonomy_id";
  	}
  
! 	if ( $show_updated ) {
! 		$recently_updated_test = ", IF (DATE_ADD(link_updated, INTERVAL 120 MINUTE) >= NOW(), 1,0) as recently_updated ";
  	} else {
  		$recently_updated_test = '';
  	}
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/class-IXR.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/class-IXR.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/class-IXR.php	2013-10-30 20:29:22.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/class-IXR.php	2014-08-06 21:51:19.000000000 +0400
***************
*** 203,213 ****
      {
          // first remove the XML declaration
          // merged from WP #10698 - this method avoids the RAM usage of preg_replace on very large messages
!         $header = preg_replace( '/<\?xml.*?\?'.'>/', '', substr($this->message, 0, 100), 1);
!         $this->message = substr_replace($this->message, $header, 0, 100);
!         if (trim($this->message) == '') {
              return false;
          }
          $this->_parser = xml_parser_create();
          // Set XML parser to take the case of tags in to account
          xml_parser_set_option($this->_parser, XML_OPTION_CASE_FOLDING, false);
--- 203,239 ----
      {
          // first remove the XML declaration
          // merged from WP #10698 - this method avoids the RAM usage of preg_replace on very large messages
!         $header = preg_replace( '/<\?xml.*?\?'.'>/s', '', substr( $this->message, 0, 100 ), 1 );
!         $this->message = trim( substr_replace( $this->message, $header, 0, 100 ) );
!         if ( '' == $this->message ) {
              return false;
          }
+ 
+         // Then remove the DOCTYPE
+         $header = preg_replace( '/^<!DOCTYPE[^>]*+>/i', '', substr( $this->message, 0, 200 ), 1 );
+         $this->message = trim( substr_replace( $this->message, $header, 0, 200 ) );
+         if ( '' == $this->message ) {
+             return false;
+         }
+ 
+         // Check that the root tag is valid
+         $root_tag = substr( $this->message, 0, strcspn( substr( $this->message, 0, 20 ), "> \t\r\n" ) );
+         if ( '<!DOCTYPE' === strtoupper( $root_tag ) ) {
+             return false;
+         }
+         if ( ! in_array( $root_tag, array( '<methodCall', '<methodResponse', '<fault' ) ) ) {
+             return false;
+         }
+ 
+         // Bail if there are too many elements to parse
+         $element_limit = 30000;
+         if ( function_exists( 'apply_filters' ) ) {
+             $element_limit = apply_filters( 'xmlrpc_element_limit', $element_limit );
+         }
+         if ( $element_limit && 2 * $element_limit < substr_count( $this->message, '<' ) ) {
+             return false;
+         }
+ 
          $this->_parser = xml_parser_create();
          // Set XML parser to take the case of tags in to account
          xml_parser_set_option($this->_parser, XML_OPTION_CASE_FOLDING, false);
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/class-wp-xmlrpc-server.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/class-wp-xmlrpc-server.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/class-wp-xmlrpc-server.php	2013-10-30 20:29:22.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/class-wp-xmlrpc-server.php	2014-04-01 01:36:11.000000000 +0400
***************
*** 5391,5401 ****
--- 5391,5408 ----
  		// very stupid, but gives time to the 'from' server to publish !
  		sleep(1);
  
+ 		$remote_ip = preg_replace( '/[^0-9a-fA-F:., ]/', '', $_SERVER['REMOTE_ADDR'] );
+ 		$user_agent = apply_filters( 'http_headers_useragent', 'WordPress/' . $GLOBALS['wp_version'] . '; ' . get_bloginfo( 'url' ) );
+ 
  		// Let's check the remote site
  		$http_api_args = array(
  			'timeout' => 10,
  			'redirection' => 0,
  			'limit_response_size' => 153600, // 150 KB
+ 			'user-agent' => "$user_agent; verifying pingback from $remote_ip",
+ 			'headers' => array(
+ 				'X-Pingback-Forwarded-For' => $remote_ip,
+ 			),
  		);
  		$linea = wp_remote_retrieve_body( wp_safe_remote_get( $pagelinkedfrom, $http_api_args ) );
  
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/compat.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/compat.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/compat.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/compat.php	2014-08-06 09:45:10.000000000 +0400
***************
*** 94,96 ****
--- 94,125 ----
  		return is_array($data) ? array_map(__FUNCTION__, $data) : $data;
  	}
  }
+ 
+ if ( ! function_exists( 'hash_equals' ) ) :
+ /**
+  * Compare two strings in constant time.
+  *
+  * This function was added in PHP 5.6.
+  * It can leak the length of a string.
+  *
+  * @since 3.9.2
+  *
+  * @param string $a Expected string.
+  * @param string $b Actual string.
+  * @return bool Whether strings are equal.
+  */
+ function hash_equals( $a, $b ) {
+ 	$a_length = strlen( $a );
+ 	if ( $a_length !== strlen( $b ) ) {
+ 		return false;
+ 	}
+ 	$result = 0;
+ 
+ 	// Do not attempt to "optimize" this.
+ 	for ( $i = 0; $i < $a_length; $i++ ) {
+ 		$result |= ord( $a[ $i ] ) ^ ord( $b[ $i ] );
+ 	}
+ 
+ 	return $result === 0;
+ }
+ endif;
\ No newline at end of file
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/cron.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/cron.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/cron.php	2013-10-30 20:29:22.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/cron.php	2014-04-01 07:40:10.000000000 +0400
***************
*** 160,167 ****
  		$args = array_slice( func_get_args(), 1 );
  	}
  
! 	while ( $timestamp = wp_next_scheduled( $hook, $args ) )
! 		wp_unschedule_event( $timestamp, $hook, $args );
  }
  
  /**
--- 160,178 ----
  		$args = array_slice( func_get_args(), 1 );
  	}
  
! 	// This logic duplicates wp_next_scheduled()
! 	// It's required due to a scenario where wp_unschedule_event() fails due to update_option() failing,
! 	// and, wp_next_scheduled() returns the same schedule in an infinite loop.
! 	$crons = _get_cron_array();
! 	if ( empty( $crons ) )
! 		return;
! 
! 	$key = md5( serialize( $args ) );
! 	foreach ( $crons as $timestamp => $cron ) {
! 		if ( isset( $cron[ $hook ][ $key ] ) ) {
! 			wp_unschedule_event( $timestamp, $hook, $args );
! 		}
! 	}
  }
  
  /**
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/functions.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/functions.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/functions.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/functions.php	2014-04-01 08:02:10.000000000 +0400
***************
*** 1372,1385 ****
  	}
  
  	// Get the permission bits.
! 	if ( $target_parent && '.' != $target_parent ) {
! 		$stat = @stat( $target_parent );
  		$dir_perms = $stat['mode'] & 0007777;
  	} else {
  		$dir_perms = 0777;
  	}
  
  	if ( @mkdir( $target, $dir_perms, true ) ) {
  		return true;
  	}
  
--- 1372,1394 ----
  	}
  
  	// Get the permission bits.
! 	$dir_perms = false;
! 	if ( $stat = @stat( $target_parent ) ) {
  		$dir_perms = $stat['mode'] & 0007777;
  	} else {
  		$dir_perms = 0777;
  	}
  
  	if ( @mkdir( $target, $dir_perms, true ) ) {
+ 
+ 		// If a umask is set that modifies $dir_perms, we'll have to re-set the $dir_perms correctly with chmod()
+ 		if ( $dir_perms != ( $dir_perms & ~umask() ) ) {
+ 			$folder_parts = explode( '/', substr( $target, strlen( $target_parent ) + 1 ) );
+ 			for ( $i = 1; $i <= count( $folder_parts ); $i++ ) {
+ 				@chmod( $target_parent . '/' . implode( '/', array_slice( $folder_parts, 0, $i ) ), $dir_perms );
+ 			}
+ 		}
+ 
  		return true;
  	}
  
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/option.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/option.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/option.php	2013-10-30 20:29:22.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/option.php	2014-04-01 08:07:09.000000000 +0400
***************
*** 757,763 ****
   		return $pre;
  
  	// prevent non-existent options from triggering multiple queries
! 	$notoptions = wp_cache_get( 'notoptions', 'site-options' );
  	if ( isset( $notoptions[$option] ) )
  		return apply_filters( 'default_site_option_' . $option, $default );
  
--- 757,764 ----
   		return $pre;
  
  	// prevent non-existent options from triggering multiple queries
! 	$notoptions_key = "{$wpdb->siteid}:notoptions";
! 	$notoptions = wp_cache_get( $notoptions_key, 'site-options' );
  	if ( isset( $notoptions[$option] ) )
  		return apply_filters( 'default_site_option_' . $option, $default );
  
***************
*** 779,785 ****
  				wp_cache_set( $cache_key, $value, 'site-options' );
  			} else {
  				$notoptions[$option] = true;
! 				wp_cache_set( 'notoptions', $notoptions, 'site-options' );
  				$value = apply_filters( 'default_site_option_' . $option, $default );
  			}
  		}
--- 780,786 ----
  				wp_cache_set( $cache_key, $value, 'site-options' );
  			} else {
  				$notoptions[$option] = true;
! 				wp_cache_set( $notoptions_key, $notoptions, 'site-options' );
  				$value = apply_filters( 'default_site_option_' . $option, $default );
  			}
  		}
***************
*** 812,817 ****
--- 813,819 ----
  	wp_protect_special_option( $option );
  
  	$value = apply_filters( 'pre_add_site_option_' . $option, $value );
+ 	$notoptions_key = "{$wpdb->siteid}:notoptions";
  
  	if ( !is_multisite() ) {
  		$result = add_option( $option, $value );
***************
*** 819,825 ****
  		$cache_key = "{$wpdb->siteid}:$option";
  
  		// Make sure the option doesn't already exist. We can check the 'notoptions' cache before we ask for a db query
! 		$notoptions = wp_cache_get( 'notoptions', 'site-options' );
  		if ( ! is_array( $notoptions ) || ! isset( $notoptions[$option] ) )
  			if ( false !== get_site_option( $option ) )
  				return false;
--- 821,827 ----
  		$cache_key = "{$wpdb->siteid}:$option";
  
  		// Make sure the option doesn't already exist. We can check the 'notoptions' cache before we ask for a db query
! 		$notoptions = wp_cache_get( $notoptions_key, 'site-options' );
  		if ( ! is_array( $notoptions ) || ! isset( $notoptions[$option] ) )
  			if ( false !== get_site_option( $option ) )
  				return false;
***************
*** 835,844 ****
  		wp_cache_set( $cache_key, $value, 'site-options' );
  
  		// This option exists now
! 		$notoptions = wp_cache_get( 'notoptions', 'site-options' ); // yes, again... we need it to be fresh
  		if ( is_array( $notoptions ) && isset( $notoptions[$option] ) ) {
  			unset( $notoptions[$option] );
! 			wp_cache_set( 'notoptions', $notoptions, 'site-options' );
  		}
  	}
  
--- 837,846 ----
  		wp_cache_set( $cache_key, $value, 'site-options' );
  
  		// This option exists now
! 		$notoptions = wp_cache_get( $notoptions_key, 'site-options' ); // yes, again... we need it to be fresh
  		if ( is_array( $notoptions ) && isset( $notoptions[$option] ) ) {
  			unset( $notoptions[$option] );
! 			wp_cache_set( $notoptions_key, $notoptions, 'site-options' );
  		}
  	}
  
***************
*** 922,931 ****
  	if ( false === $old_value )
  		return add_site_option( $option, $value );
  
! 	$notoptions = wp_cache_get( 'notoptions', 'site-options' );
  	if ( is_array( $notoptions ) && isset( $notoptions[$option] ) ) {
  		unset( $notoptions[$option] );
! 		wp_cache_set( 'notoptions', $notoptions, 'site-options' );
  	}
  
  	if ( !is_multisite() ) {
--- 924,934 ----
  	if ( false === $old_value )
  		return add_site_option( $option, $value );
  
! 	$notoptions_key = "{$wpdb->siteid}:notoptions";
! 	$notoptions = wp_cache_get( $notoptions_key, 'site-options' );
  	if ( is_array( $notoptions ) && isset( $notoptions[$option] ) ) {
  		unset( $notoptions[$option] );
! 		wp_cache_set( $notoptions_key, $notoptions, 'site-options' );
  	}
  
  	if ( !is_multisite() ) {
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/pluggable.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/pluggable.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/pluggable.php	2013-10-30 20:29:22.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/pluggable.php	2014-08-06 21:59:09.000000000 +0400
***************
*** 546,552 ****
  	$key = wp_hash($username . $pass_frag . '|' . $expiration, $scheme);
  	$hash = hash_hmac('md5', $username . '|' . $expiration, $key);
  
! 	if ( $hmac != $hash ) {
  		do_action('auth_cookie_bad_hash', $cookie_elements);
  		return false;
  	}
--- 546,552 ----
  	$key = wp_hash($username . $pass_frag . '|' . $expiration, $scheme);
  	$hash = hash_hmac('md5', $username . '|' . $expiration, $key);
  
! 	if ( ! hash_equals( $hash, $hmac ) ) {
  		do_action('auth_cookie_bad_hash', $cookie_elements);
  		return false;
  	}
***************
*** 1297,1307 ****
  	$i = wp_nonce_tick();
  
  	// Nonce generated 0-12 hours ago
! 	if ( substr(wp_hash($i . $action . $uid, 'nonce'), -12, 10) === $nonce )
  		return 1;
  	// Nonce generated 12-24 hours ago
! 	if ( substr(wp_hash(($i - 1) . $action . $uid, 'nonce'), -12, 10) === $nonce )
  		return 2;
  	// Invalid nonce
  	return false;
  }
--- 1297,1313 ----
  	$i = wp_nonce_tick();
  
  	// Nonce generated 0-12 hours ago
! 	$expected = substr( wp_hash( $i . '|' . $action . '|' . $uid, 'nonce'), -12, 10 );
! 	if ( hash_equals( $expected, $nonce ) ) {
  		return 1;
+ 	}
+ 
  	// Nonce generated 12-24 hours ago
! 	$expected = substr( wp_hash( ( $i - 1 ) . '|' . $action . '|' . $uid, 'nonce' ), -12, 10 );
! 	if ( hash_equals( $expected, $nonce ) ) {
  		return 2;
+ 	}
+ 
  	// Invalid nonce
  	return false;
  }
***************
*** 1324,1330 ****
  
  	$i = wp_nonce_tick();
  
! 	return substr(wp_hash($i . $action . $uid, 'nonce'), -12, 10);
  }
  endif;
  
--- 1330,1336 ----
  
  	$i = wp_nonce_tick();
  
! 	return substr(wp_hash($i . '|' . $action . '|' . $uid, 'nonce'), -12, 10);
  }
  endif;
  
***************
*** 1703,1709 ****
  		$out = str_replace( '&#038;', '&amp;', esc_url( $out ) );
  		$avatar = "<img alt='{$safe_alt}' src='{$out}' class='avatar avatar-{$size} photo' height='{$size}' width='{$size}' />";
  	} else {
! 		$avatar = "<img alt='{$safe_alt}' src='{$default}' class='avatar avatar-{$size} photo avatar-default' height='{$size}' width='{$size}' />";
  	}
  
  	return apply_filters('get_avatar', $avatar, $id_or_email, $size, $default, $alt);
--- 1709,1716 ----
  		$out = str_replace( '&#038;', '&amp;', esc_url( $out ) );
  		$avatar = "<img alt='{$safe_alt}' src='{$out}' class='avatar avatar-{$size} photo' height='{$size}' width='{$size}' />";
  	} else {
! 		$out = esc_url( $default );
! 		$avatar = "<img alt='{$safe_alt}' src='{$out}' class='avatar avatar-{$size} photo avatar-default' height='{$size}' width='{$size}' />";
  	}
  
  	return apply_filters('get_avatar', $avatar, $id_or_email, $size, $default, $alt);
***************
*** 1784,1786 ****
--- 1791,1825 ----
  }
  endif;
  
+ if ( ! function_exists( 'hash_equals' ) ) :
+ /**
+  * Compare two strings in constant time.
+  *
+  * This function is NOT pluggable. It is in this file (in addition to
+  * compat.php) to prevent errors if, during an update, pluggable.php
+  * copies over but compat.php does not.
+  *
+  * This function was added in PHP 5.6.
+  * It can leak the length of a string.
+  *
+  * @since 3.9.2
+  *
+  * @param string $a Expected string.
+  * @param string $b Actual string.
+  * @return bool Whether strings are equal.
+  */
+ function hash_equals( $a, $b ) {
+ 	$a_length = strlen( $a );
+ 	if ( $a_length !== strlen( $b ) ) {
+ 		return false;
+ 	}
+ 	$result = 0;
+ 
+ 	// Do not attempt to "optimize" this.
+ 	for ( $i = 0; $i < $a_length; $i++ ) {
+ 		$result |= ord( $a[ $i ] ) ^ ord( $b[ $i ] );
+ 	}
+ 
+ 	return $result === 0;
+ }
+ endif;
